package ir.cristiansoft.wallpaper;

import android.Manifest;
import android.app.Activity;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.design.widget.Snackbar;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.widget.AppCompatImageView;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.Toast;

import com.squareup.picasso.Picasso;

public class FullscreenActivity extends Activity {

    byte b = 1;
    int wallpaper_id;

    RelativeLayout relativeLayout;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_fullscreen);

        AppCompatImageView imgFull = findViewById(R.id.img_full);
        ImageView btnSave = findViewById(R.id.btn_save);
        ImageView btnSetBack = findViewById(R.id.btn_set_back);
        ImageView btnShare = findViewById(R.id.btn_share);

        relativeLayout = findViewById(R.id.relativeLayout);

        final LinearLayout linearLayout = findViewById(R.id.linearLayout);
        linearLayout.setVisibility(View.INVISIBLE);

        wallpaper_id = getIntent().getIntExtra("resource_id" , 0);

        if (wallpaper_id != 0)
        {
            Picasso.with(this).load(wallpaper_id).into(imgFull);
        }

        btnSetBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                boolean success = FeaturesHelper.setAsWallpaper(FullscreenActivity.this , wallpaper_id);
                if(success)
                {
                    Snackbar.make(v, "Wallpaper change successfully !", Snackbar.LENGTH_LONG)
                            .show();
                }
                else
                {
                    Snackbar.make(v, "Sorry, Wallpaper not changed !!!", Snackbar.LENGTH_LONG)
                            .show();
                }
            }
        });

        btnSave.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {


                if (Build.VERSION.SDK_INT >=23)
                {
                    if (ContextCompat.checkSelfPermission(FullscreenActivity.this ,
                            Manifest.permission.WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED)
                    {
                        ActivityCompat.requestPermissions(FullscreenActivity.this ,
                                new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE} , 1);
                    }
                    else
                    {
                        boolean success = FeaturesHelper.downloadWallpaper(FullscreenActivity.this , wallpaper_id);
                        if(success)
                        {
                            Snackbar.make(v, "Wallpaper saved successfully !", Snackbar.LENGTH_LONG)
                                    .show();
                        }
                        else
                        {
                            Snackbar.make(v, "Sorry, Wallpaper cannot saved !!!", Snackbar.LENGTH_LONG)
                                    .show();
                        }
                    }
                }
                else
                {
                    boolean success = FeaturesHelper.downloadWallpaper(FullscreenActivity.this , wallpaper_id);
                    if(success)
                    {
                        Snackbar.make(v, "Wallpaper saved successfully !", Snackbar.LENGTH_LONG)
                                .show();
                    }
                    else
                    {
                        Snackbar.make(v, "Sorry, Wallpaper cannot saved !!!", Snackbar.LENGTH_LONG)
                                .show();
                    }
                }
            }
        });

        btnShare.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                FeaturesHelper.shareWallpaper(FullscreenActivity.this , wallpaper_id);
            }
        });

        imgFull.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(b == 0)
                {
                    linearLayout.setVisibility(View.INVISIBLE);
                    b = 1;
                }
                else
                {
                    linearLayout.setVisibility(View.VISIBLE);
                    b = 0;
                }
            }
        });


    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        switch (requestCode) {
            case 1: {
                if (grantResults.length <=1 && grantResults[0] == PackageManager.PERMISSION_DENIED)
                {
                    Snackbar.make(relativeLayout, "Sorry, Wallpaper cannot saved !!!", Snackbar.LENGTH_LONG)
                            .show();
                }
                else
                {
                    boolean success = FeaturesHelper.downloadWallpaper(FullscreenActivity.this , wallpaper_id);
                    if(success)
                    {
                        Snackbar.make(relativeLayout, "Wallpaper saved successfully !", Snackbar.LENGTH_LONG)
                                .show();
                    }
                    else
                    {
                        Snackbar.make(relativeLayout, "Sorry, Wallpaper cannot saved !!!", Snackbar.LENGTH_LONG)
                                .show();
                    }
                }
            }
        }
    }
}
